function matlab_contrastenhancement(...
    Ic_in, Ig_in, Ig_base, LUTfile, ...
    name_Ic_out, name_Ig_detail, name_Ig_base, name_Ic_gamma)

% WARNING:
% This script change since the last demo: we're now using a scheme which is
% closer to the DxO's one. Namely, we use the DOP amplifications LUT, and
% apply it to the input image, rather than to the base only.

alpha           = 0.6;  % The Detail Amplification is constant in DOP 
                        % for the lighting V3 "strong"

LUTfile_id      = fopen(LUTfile,'r');
doplut          = NaN(32768,1);
for n=1:32768
    doplut(n)   = str2double(fgetl(LUTfile_id));
end
fclose(LUTfile_id);
doplut          = doplut(1:128:end)/128; % We're working on 8bits, not 15

Ig_base         = double(imread(Ig_base));
Ig_base_mod     = doplut(1+Ig_base);

fprintf('Writting %s ...',name_Ig_base);
imwrite(uint8(Ig_base_mod),name_Ig_base);
fprintf('ok\n');

expo_coeffs     = Ig_base_mod./Ig_base;             clear Ig_base_mod;

Ig_in           = double(imread(Ig_in));
Ig_detail       = Ig_in - Ig_base;                  clear Ig_base;

Ig_detail_mod   = alpha*Ig_detail;                  clear Ig_detail;
Ig_in_mod       = Ig_in + Ig_detail_mod;

fprintf('Writting %s ...',name_Ig_detail);
imwrite(uint8(128 + 5*Ig_detail_mod),name_Ig_detail);
fprintf('ok\n');                                    clear Ig_detail_mod;

detail_coeffs   = Ig_in_mod./Ig_in;
total_coeffs    = expo_coeffs.*detail_coeffs;       clear detail_coeffs;

Ic_in           = double(imread(Ic_in));
Ic_out          = zeros(size(Ic_in));
Ic_out(:,:,1)   = Ic_in(:,:,1).*total_coeffs;
Ic_out(:,:,2)   = Ic_in(:,:,2).*total_coeffs;
Ic_out(:,:,3)   = Ic_in(:,:,3).*total_coeffs;

% fprintf('Writting %s ...','Amplification Coeffs');
% imwrite(uint8(128 + 25*total_coeffs),'ampli_coeffs_x25.png');
% fprintf('ok\n');

fprintf('Writting %s ...',name_Ic_out);
imwrite(uint8(Ic_out),name_Ic_out);                 clear Ic_out;
fprintf('ok\n');

simple_coeffs   = doplut(1+Ig_in)./Ig_in;           clear Ig_in;

Ic_gamma        = zeros(size(Ic_in));
Ic_gamma(:,:,1) = Ic_in(:,:,1).*simple_coeffs;
Ic_gamma(:,:,2) = Ic_in(:,:,2).*simple_coeffs;
Ic_gamma(:,:,3) = Ic_in(:,:,3).*simple_coeffs;

fprintf('Writting %s ...',name_Ic_gamma);           clear Ic_in;
imwrite(uint8(Ic_gamma),name_Ic_gamma);             clear Ic_gamma;
fprintf('ok\n');
end
